/**
 * Creates and AT Internet SmartTag and dispatches it.
 */
(function ($, Drupal, once, drupalSettings) {

  if (drupalSettings.atsmarttag !== undefined) {

    drupalSettings.atsmarttag.createTagAndDispatch = function () {
      let tag_properties = {};
      if (!!drupalSettings.atsmarttag.site) {
        tag_properties.site = drupalSettings.atsmarttag.site;
      }
      if (!!drupalSettings.atsmarttag.collect_domain) {
        tag_properties.collectDomain = drupalSettings.atsmarttag.collect_domain;
      }
      if (!!drupalSettings.atsmarttag.collect_domain_ssl) {
        tag_properties.collectDomainSSL = drupalSettings.atsmarttag.collect_domain_ssl;
      }
      if (drupalSettings.atsmarttag.secure !== 0) {
        tag_properties.secure = true;
      }
      if (drupalSettings.atsmarttag.disable_cookie !== 0) {
        tag_properties.disableCookie = true;
      }
      if (!!drupalSettings.atsmarttag.cookie_domain) {
        tag_properties.cookieDomain = drupalSettings.atsmarttag.cookie_domain;
      }
      window.ATTag = new window.ATInternet.Tracker.Tag(tag_properties);
      if (drupalSettings.atsmarttag.cnil_exempt !== 0) {
        if (window.ATTag.privacy) {
          window.ATTag.privacy.setVisitorMode('cnil', 'exempt');
        } else {
          console.log("CNIL exemption requires the Privacy plugin.");
        }
      }
      let page_properties = {};
      if (!!drupalSettings.atsmarttag.page_name) {
        page_properties.name = drupalSettings.atsmarttag.page_name;
      }
      if (!!drupalSettings.atsmarttag.page_chapter1) {
        page_properties.chapter1 = drupalSettings.atsmarttag.page_chapter1;
      }
      if (!!drupalSettings.atsmarttag.page_chapter2) {
        page_properties.chapter2 = drupalSettings.atsmarttag.page_chapter2;
      }
      if (!!drupalSettings.atsmarttag.page_chapter3) {
        page_properties.chapter3 = drupalSettings.atsmarttag.page_chapter3;
      }
      if (Object.getOwnPropertyNames(page_properties).length > 0) {
        window.ATTag.page.set(page_properties);
        window.ATTag.dispatch();
      }
      $(document).ready(function () {
        $(document).trigger('atsmarttag:tag_initialized');
      });
    };

    Drupal.behaviors.atsmarttag = {
      attach: function (context, settings) {
        once('atsmarttag', 'html', context).forEach(function (element) {
          settings.atsmarttag.createTagAndDispatch();
        });
      }
    };
  }

})(jQuery, Drupal, once, drupalSettings);
