<?php

namespace Drupal\atsmarttag;

class ATSmartTagUtils {

  public static function getLibraryInfoFromUrl($url) {
    $library_info = [
      // Load script in header.
      'header' => TRUE,
      'js' => [
        $url => [
          // Is an external URL.
          'external' => TRUE,
        ],
      ],
    ];
    return $library_info;
  }

  public static function getLibraryInfoFromFile($file) {
    $uri = $file->getFileUri();
    $path = self::getFilePathRelativeToDrupalRoot($uri);
    $library_info = [
      // Load script in header.
      'header' => TRUE,
      'js' => [
        $path => [
          // Preprocess allows aggregation for better performance.
          'preprocess' => TRUE,
        ],
      ],
    ];
    return $library_info;
  }

  /**
   *
   */
  private static function getFilePathRelativeToDrupalRoot($uri) {
    $path = \Drupal::service('file_url_generator')->generateAbsoluteString($uri);
    return str_replace(base_path(), '/', parse_url($path, PHP_URL_PATH));
  }

}
